unit adxOLTest191_IMPL;

interface

uses
  ComObj, ComServ, ActiveX, Variants, axpAddIn, adxOLTest191_TLB,
  SysUtils, Classes, Graphics, Dialogs, Office2000, Outlook2000;

type
  { TADX_OLTest191 }
  TADX_OLTest191 = class(TaxpAddIn, IADX_OLTest191)
  private
    FExplorers: TExplorers;
    FExplorerList: TList;
  protected
    procedure AddIn_Initialize; override;
    procedure AddIn_Finalize; override;
    procedure AddIn_ControlEvent(const Tag: string; ICtrl: IaxpControl); override;
  public
    procedure DoNewExplorer(ASender: TObject; const Explorer: _Explorer);
    procedure DoExplorerActivate(ASender: TObject);
    procedure DoExplorerClose(ASender: TObject);
  end;

implementation

{ TADX_OLTest191 }

procedure TADX_OLTest191.AddIn_Initialize;
var
  isNew: boolean;
begin
  inherited AddIn_Initialize;
  if OutlookApp.ActiveExplorer <> nil then begin
    AddCmdBar('TEST BAR', isNew, msoBarTop, True);

    AddButton('TEST BAR', 'Button1', 'TAG_BUTTON1', '', '', msoButtonCaption, isNew, -1, nil, clDefault, True);
    AddButton('TEST BAR', 'Button2', 'TAG_BUTTON2', '', '', msoButtonCaption, isNew, -1, nil, clDefault, True);
    AddButton('TEST BAR', 'Button3', 'TAG_BUTTON3', '', '', msoButtonCaption, isNew, -1, nil, clDefault, True);

    FExplorerList := TList.Create;

    FExplorers := TExplorers.Create(nil);
    FExplorers.ConnectTo(OutlookApp.Explorers);
    FExplorers.OnNewExplorer := DoNewExplorer;
  end;
end;

procedure TADX_OLTest191.AddIn_Finalize;
var
  i: Integer;
begin
  if Assigned(FExplorerList) then begin
    for i := 0 to FExplorerList.Count - 1 do
      TExplorer(FExplorerList[i]).Free;
    FExplorerList.Free;
  end;
  if Assigned(FExplorers) then FreeAndNil(FExplorers);
  inherited AddIn_Finalize;
end;

procedure TADX_OLTest191.AddIn_ControlEvent(const Tag: string; ICtrl: IaxpControl);
begin
  ShowMessage(ICtrl.Caption);
end;

procedure TADX_OLTest191.DoNewExplorer(ASender: TObject; const Explorer: _Explorer);
var
  FExplorer: TExplorer;
begin
  if Assigned(Explorer) then begin
    FExplorer := TExplorer.Create(nil);
    FExplorer.ConnectTo(Explorer);
    FExplorer.OnActivate := DoExplorerActivate;
    FExplorer.OnClose := DoExplorerClose;
    FExplorerList.Add(FExplorer);
  end;
end;

procedure TADX_OLTest191.DoExplorerActivate(ASender: TObject);
var
  isNew: boolean;
  CmdBars: IaxpCmdBars;
begin
  if ASender is TExplorer then begin
    CmdBars := (ASender as TExplorer).CommandBars as IaxpCmdBars;
    try
      AddCmdBar(CmdBars, 'TEST BAR', isNew, msoBarTop, True);
      if isNew then begin
        // adding the first control raises a strange exception in Outlook 2000 SP3
        try
          AddButton(CmdBars, 'TEST BAR', 'Button1', 'TAG_BUTTON1', '', '', msoButtonCaption, isNew, -1, nil, clDefault, True);
        except
          AddButton(CmdBars, 'TEST BAR', 'Button1', 'TAG_BUTTON1', '', '', msoButtonCaption, isNew, -1, nil, clDefault, True);
        end;
        AddButton(CmdBars, 'TEST BAR', 'Button2', 'TAG_BUTTON2', '', '', msoButtonCaption, isNew, -1, nil, clDefault, True);
        AddButton(CmdBars, 'TEST BAR', 'Button3', 'TAG_BUTTON3', '', '', msoButtonCaption, isNew, -1, nil, clDefault, True);
      end;
    finally
      CmdBars := nil;
    end;
  end;
end;

procedure TADX_OLTest191.DoExplorerClose(ASender: TObject);
var
  Index: Integer;
begin
  Index := FExplorerList.IndexOf(ASender);
  if Index > -1 then begin
    TExplorer(FExplorerList[Index]).Free;
    FExplorerList.Delete(Index);
  end;
end;

initialization
  TaxpFactory.CreateEx(ComServer, TADX_OLTest191, CLASS_ADX_OLTest191,
    [ohaOutlook],
    'adxOLTest191', '');

end.
